module Util where

import Data.List
import Control.Monad

data Verbosity = Silent | Quiet | Verbose | Trace | SuperTrace deriving (Eq,Ord,Show)


number x = zip [0..] x

split a = ([x | (x,b) <- zip a bl,b], [x | (x,b) <- zip a bl,not b])
  where bl = unfoldr (\b -> Just (b,not b)) True

splitN n a = [[x | (x,i) <- zip a il, i==j] | j <- [0..(n-1)]]
  where il = unfoldr (\b -> Just (b,(b+1) `mod` n)) 0

replaceNth [] _ _ = []
replaceNth (_:xs) 0 y = y : xs
replaceNth (x:xs) n y = x : replaceNth xs (n-1) y

for lo hi f = flip mapM_ [lo..hi] f

boolToInt True = 1
boolToInt False = 0

linesOn :: Char -> String -> [String]
linesOn c s = case dropWhile (==c) s of
                "" -> []
                s' -> let (w,s'') = break (==c) s' 
                      in  w : linesOn c s''

putStrIf   b str = when b $ putStr   str
putStrIfLn b str = when b $ putStrLn str
printIf    b str = when b $ print    str

fst3 (a,b,c) = a
snd3 (a,b,c) = b
thr3 (a,b,c) = c
